#include <bits/stdc++.h>
using namespace std;
#define ll long double
stack<int> ans;
vector<bool> used;
vector<ll> c;
set<int> x;
vector<stack<int>> y;
void perebor(int n) {
    if (n > 0) {
        set<int> m = x;
        for (auto i: m) {
            ans.push(i);
            x.erase(i);
            perebor(n - 1);
            ans.pop();
            x.insert(i);
        }
    } else {
        y.push_back(ans);
    }
}
pair<ll,ll> pryamaya(pair<ll, ll> a, pair<ll, ll> b) {
    return {(a.second - b.second) / (a.first - b.first), (a.second - b.second) / (a.first - b.first) * b.first + a.second};
}
pair<ll,ll> parallel(pair<ll, ll> a, pair<ll, ll> b) {
    return {a.first, a.second - a.first * b.first};
}
pair<ll,ll> perpend(pair<ll, ll> a) {
    return {-1/a.first,0};
}
pair<ll,ll> peresech(pair<ll, ll> a, pair<ll, ll> b) {
    ll x = (b.second - a.second) / (a.first - b.first);
    return {x, a.first * x + a.second};
}
ll dlina(pair<ll, ll> a, pair<ll, ll> b) {
    return sqrtl((a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second));
}
int main() {
    int n;
    cout << fixed << setprecision(12);
    cin >> n;
    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; i++) {
        x.insert(i);
        cin >> a[i].first >> a[i].second;
    }
    perebor(n);
    if (n == 2) {
        cout << dlina(a[0], a[1]);
    } else {
        ll ans = 2e6;
        for (int i = 0; i < y.size(); i++) {
            int q = y[i].top();
            y[i].pop();
            int w = y[i].top();
            y[i].pop();
            int s = y[i].top();
            y[i].pop();
            ans = min(ans, dlina(a[q], a[w]) + dlina(a[s], peresech(pryamaya(a[q], a[w]), parallel(perpend(pryamaya(a[q], a[w])), a[s]))));
        }
        cout << ans;
    }
}
